<?php
/*
This file has been generated by the Sabai scaffold script. Do not edit this file directly.
If you need to customize the class, use the following file:
pluginsy/OpenIDAuth/Model/AssocGateway.php
*/
abstract class Plugg_OpenIDAuth_Model_Base_AssocGateway extends Sabai_Model_Gateway
{
    public function getName()
    {
        return 'assoc';
    }

    public function getFields()
    {
        return array('assoc_id' => Sabai_Model::KEY_TYPE_INT, 'assoc_created' => Sabai_Model::KEY_TYPE_INT, 'assoc_updated' => Sabai_Model::KEY_TYPE_INT, 'assoc_server_url' => Sabai_Model::KEY_TYPE_VARCHAR, 'assoc_handle' => Sabai_Model::KEY_TYPE_VARCHAR, 'assoc_secret' => Sabai_Model::KEY_TYPE_BLOB, 'assoc_issued' => Sabai_Model::KEY_TYPE_INT, 'assoc_lifetime' => Sabai_Model::KEY_TYPE_INT, 'assoc_type' => Sabai_Model::KEY_TYPE_VARCHAR);
    }

    protected function _getSelectByIdQuery($id, $fields)
    {
        return sprintf(
            'SELECT %s FROM %sassoc WHERE assoc_id = %d',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $id
        );
    }

    protected function _getSelectByIdsQuery($ids, $fields)
    {
        return sprintf(
            'SELECT %s FROM %sassoc WHERE assoc_id IN (%s)',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            implode(',', array_map('intval', $ids))
        );
    }

    protected function _getSelectByCriteriaQuery($criteriaStr, $fields)
    {
        return sprintf(
            'SELECT %1$s FROM %2$sassoc WHERE %3$s',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $criteriaStr
        );
    }

    protected function _getInsertQuery($values)
    {
        $values['assoc_created'] = time();
        $values['assoc_updated'] = 0;
        return sprintf("INSERT INTO %sassoc(assoc_created, assoc_updated, assoc_server_url, assoc_handle, assoc_secret, assoc_issued, assoc_lifetime, assoc_type) VALUES(%d, %d, %s, %s, %s, %d, %d, %s)", $this->_db->getResourcePrefix(), $values['assoc_created'], $values['assoc_updated'], $this->_db->escapeString($values['assoc_server_url']), $this->_db->escapeString($values['assoc_handle']), $this->_db->escapeBlob($values['assoc_secret']), $values['assoc_issued'], $values['assoc_lifetime'], $this->_db->escapeString($values['assoc_type']));
    }

    protected function _getUpdateQuery($id, $values)
    {
        $last_update = $values['assoc_updated'];
        $values['assoc_updated'] = time();
        return sprintf("UPDATE %sassoc SET assoc_updated = %d, assoc_server_url = %s, assoc_handle = %s, assoc_secret = %s, assoc_issued = %d, assoc_lifetime = %d, assoc_type = %s WHERE assoc_id = %d AND assoc_updated = %d", $this->_db->getResourcePrefix(), $values['assoc_updated'], $this->_db->escapeString($values['assoc_server_url']), $this->_db->escapeString($values['assoc_handle']), $this->_db->escapeBlob($values['assoc_secret']), $values['assoc_issued'], $values['assoc_lifetime'], $this->_db->escapeString($values['assoc_type']), $id, $last_update);
    }

    protected function _getDeleteQuery($id)
    {
        return sprintf('DELETE FROM %1$sassoc WHERE assoc_id = %2$d', $this->_db->getResourcePrefix(), $id);
    }

    protected function _getUpdateByCriteriaQuery($criteriaStr, $sets)
    {
        $sets['assoc_updated'] = 'assoc_updated=' . time();
        return sprintf('UPDATE %sassoc SET %s WHERE %s', $this->_db->getResourcePrefix(), implode(',', $sets), $criteriaStr);
    }

    protected function _getDeleteByCriteriaQuery($criteriaStr)
    {
        return sprintf('DELETE FROM %1$sassoc WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _getCountByCriteriaQuery($criteriaStr)
    {
        return sprintf('SELECT COUNT(*) FROM %1$sassoc WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }
}