<?php
/*
This file has been generated by the Sabai scaffold script. Do not edit this file directly.
If you need to customize the class, use the following file:
pluginsy/OpenIDAuth/Model/NonceGateway.php
*/
abstract class Plugg_OpenIDAuth_Model_Base_NonceGateway extends Sabai_Model_Gateway
{
    public function getName()
    {
        return 'nonce';
    }

    public function getFields()
    {
        return array('nonce_id' => Sabai_Model::KEY_TYPE_INT, 'nonce_created' => Sabai_Model::KEY_TYPE_INT, 'nonce_updated' => Sabai_Model::KEY_TYPE_INT, 'nonce_server_url' => Sabai_Model::KEY_TYPE_VARCHAR, 'nonce_timestamp' => Sabai_Model::KEY_TYPE_INT, 'nonce_salt' => Sabai_Model::KEY_TYPE_CHAR);
    }

    protected function _getSelectByIdQuery($id, $fields)
    {
        return sprintf(
            'SELECT %s FROM %snonce WHERE nonce_id = %d',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $id
        );
    }

    protected function _getSelectByIdsQuery($ids, $fields)
    {
        return sprintf(
            'SELECT %s FROM %snonce WHERE nonce_id IN (%s)',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            implode(',', array_map('intval', $ids))
        );
    }

    protected function _getSelectByCriteriaQuery($criteriaStr, $fields)
    {
        return sprintf(
            'SELECT %1$s FROM %2$snonce WHERE %3$s',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $criteriaStr
        );
    }

    protected function _getInsertQuery($values)
    {
        $values['nonce_created'] = time();
        $values['nonce_updated'] = 0;
        return sprintf("INSERT INTO %snonce(nonce_created, nonce_updated, nonce_server_url, nonce_timestamp, nonce_salt) VALUES(%d, %d, %s, %d, %s)", $this->_db->getResourcePrefix(), $values['nonce_created'], $values['nonce_updated'], $this->_db->escapeString($values['nonce_server_url']), $values['nonce_timestamp'], $this->_db->escapeString($values['nonce_salt']));
    }

    protected function _getUpdateQuery($id, $values)
    {
        $last_update = $values['nonce_updated'];
        $values['nonce_updated'] = time();
        return sprintf("UPDATE %snonce SET nonce_updated = %d, nonce_server_url = %s, nonce_timestamp = %d, nonce_salt = %s WHERE nonce_id = %d AND nonce_updated = %d", $this->_db->getResourcePrefix(), $values['nonce_updated'], $this->_db->escapeString($values['nonce_server_url']), $values['nonce_timestamp'], $this->_db->escapeString($values['nonce_salt']), $id, $last_update);
    }

    protected function _getDeleteQuery($id)
    {
        return sprintf('DELETE FROM %1$snonce WHERE nonce_id = %2$d', $this->_db->getResourcePrefix(), $id);
    }

    protected function _getUpdateByCriteriaQuery($criteriaStr, $sets)
    {
        $sets['nonce_updated'] = 'nonce_updated=' . time();
        return sprintf('UPDATE %snonce SET %s WHERE %s', $this->_db->getResourcePrefix(), implode(',', $sets), $criteriaStr);
    }

    protected function _getDeleteByCriteriaQuery($criteriaStr)
    {
        return sprintf('DELETE FROM %1$snonce WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _getCountByCriteriaQuery($criteriaStr)
    {
        return sprintf('SELECT COUNT(*) FROM %1$snonce WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }
}